Bug 8387 - border-left/padding-left do not show up on multiline rtl inline boxes
Summary: border-left/padding-left do not show up on multiline rtl inline boxes
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: 420+
Hardware: Macintosh OS X 10.4
: P2 Normal
Assignee: Nobody
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2006-04-14 12:38 PDT by Sam Weinig
Modified: 2006-05-14 09:35 PDT (History)
0 users

See Also:


Attachments
test case (2.61 KB, text/html)
2006-04-14 12:41 PDT, Sam Weinig
no flags Details
patch (5.68 KB, patch)
2006-04-15 13:23 PDT, Sam Weinig
no flags Details | Formatted Diff | Diff
test case without bidi overide (2.70 KB, text/html)
2006-04-17 14:50 PDT, Sam Weinig
no flags Details
test case with inner spans going in opposite directions of there parent (2.93 KB, text/html)
2006-04-17 14:51 PDT, Sam Weinig
no flags Details
test case with opposite direction inner spans and no bidi overide (2.80 KB, text/html)
2006-04-17 14:52 PDT, Sam Weinig
no flags Details
test case using hebrew text (1.91 KB, text/html)
2006-04-17 14:53 PDT, Sam Weinig
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sam Weinig 2006-04-14 12:38:54 PDT
No border or padding is applied for the left on a multi-line rtl inline box flow.  I am not shore what the correct behavior is supposed to be, but the right side is painted at the begining of the flow (in the ltr context the right side is at the end) so I assume the left should be at the end.
Comment 1 Sam Weinig 2006-04-14 12:41:16 PDT
Created attachment 7708 [details]
test case

This test case shows both ltr and rtl of the same text documenting both single and multiline inline boxes.
Comment 2 Joost de Valk (AlthA) 2006-04-14 12:49:26 PDT
I confirm the behavior is wrong, this sounds like one mitz find interesting.
Comment 3 Sam Weinig 2006-04-15 13:23:58 PDT
Created attachment 7733 [details]
patch

Simple 1 line fix with new layout test.
Comment 4 Sam Weinig 2006-04-17 14:48:54 PDT
While the patch does fix the functionality shown in the test case and cause no regressions that I could find, in my testing I found that the issue persists in a lot of other corner cases.  I am going to attach a couple more test cases that demonstrate. 
Comment 5 Sam Weinig 2006-04-17 14:50:07 PDT
Created attachment 7779 [details]
test case without bidi overide
Comment 6 Sam Weinig 2006-04-17 14:51:10 PDT
Created attachment 7780 [details]
test case with inner spans going in opposite directions of there parent
Comment 7 Sam Weinig 2006-04-17 14:52:05 PDT
Created attachment 7781 [details]
test case with opposite direction inner spans and no bidi overide
Comment 8 Sam Weinig 2006-04-17 14:53:30 PDT
Created attachment 7782 [details]
test case using hebrew text
Comment 9 Dave Hyatt 2006-05-07 15:20:32 PDT
Comment on attachment 7733 [details]
patch

r=me
Comment 10 Alexey Proskuryakov 2006-05-13 10:14:47 PDT
After applying the change to rendering/InlineFlowBox.cpp, the results don't really look like they are supposed to be (multiline boxes only get one colored border).
Comment 11 Alexey Proskuryakov 2006-05-13 10:22:29 PDT
Comment on attachment 7733 [details]
patch

Clearing the review flag for now.
Comment 12 Alexey Proskuryakov 2006-05-14 09:35:22 PDT
The test case was affected by bug 8392, so I have slightly modified it before landing. It should work OK in run-webkit-tests now, but it still depends on the window width, so it may fail when tried manually.